/*
    S60Bible A Bible Reader for SymbianOS
    Copyright (C) 2004 Yohanes Nugroho

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

    Yohanes Nugroho (yohanes@opensource.or.id)
    Kp Areman RT 09/08 No 71 Desa Tugu Cimanggis Depok 16951 Indonesia
*/

#ifndef __BIBLESETTINGLIST_H__
#define __BIBLESETTINGLIST_H__


#include <coecntrl.h>
#include <aknview.h> 
#include <aknsettingitemlist.h>

class CBibleSettingList : public CAknSettingItemList
{
public:
	static CBibleSettingList* NewL(CAknView *aView);
	static CBibleSettingList* NewLC(CAknView *aView);
	virtual ~CBibleSettingList();
	void SizeChanged();
	void EditCurrentItemL();
	TInt iBackLight;
	TBool iFullScreen;
	TBool iFullBookName;
	void Draw(const TRect& aRect) const;
private:
	CBibleSettingList(CAknView *aView);
	CAknSettingItem* CreateSettingItemL (TInt aSettingId);
	CAknView *iView;
	
};

#endif 
