/*
    S60Bible A Bible Reader for SymbianOS
    Copyright (C) 2004 Yohanes Nugroho

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

    Yohanes Nugroho (yohanes@opensource.or.id)
    Kp Areman RT 09/08 No 71 Desa Tugu Cimanggis Depok 16951 Indonesia
*/


#ifndef PDBACCESS_H
#define PDBACCESS_H
#include "const.h"


#ifdef USE_LIB_C
#include <stdio.h>
#include <stdlib.h>
//#include "usermem.h"
#else
#include <e32std.h>
#include <w32std.h>
#endif


struct pdb_header {       /* 78 bytes total */
	  char	 name[ dmDBNameLength ]; /*0*/
	  Word	 attributes; /* 32 */
	  Word	 version; /* 34 */
	  DWord	 create_time; /* 36 */
	  DWord	 modify_time; /* 40 */
	  DWord	 backup_time; /* 44 */
	  DWord	 modificationNumber; /* 48 */
	  DWord	 appInfoID; /* 52 */
	  DWord	 sortInfoID; /* 56*/
	  char	 type[4]; /* 60 */
	  char	 creator[4]; /* 64 */
	  DWord	 id_seed; /*68 */
	  DWord	 nextRecordList; /*72*/
	  Word	 numRecords; /* 76 */
}  /*__attribute__((packed)) */;

struct pdb_rec_header {   /* 8 bytes total	*/
	  DWord	 offset;
	  char attr;
/*	  struct {
		 int deleted    : 1;
		 int dirty     : 1;
		 int busy      : 1;
		 int secret    : 1;
		 int category  : 4;
	  }	 attributes;*/
	  char	 uniqueID[3];
} /*__attribute__((packed))*/;

class PDBAccess {
	public:
		IMPORT_C PDBAccess();
#ifdef USE_LIB_C
		IMPORT_C void ConstructL(RFs &fsSession, const char *filename);
#else
		IMPORT_C void ConstructL(RFs &fsSession, const TDesC &filename);
#endif
		char* readRecord(int recno);
		IMPORT_C ~PDBAccess();
	private:
#ifdef USE_LIB_C
		FILE *file;
#else
		RFile file;
#endif
		int filesize;
		int recordcount;
		struct pdb_header pdbheader;
		struct pdb_rec_header *records;
};



#endif

