/*
    S60Bible A Bible Reader for SymbianOS
    Copyright (C) 2004 Yohanes Nugroho

    Original work (PalmBible and Bible+):
    Copyright (C) 2001  Ho Chuen Poon
    Modifications (C) 2003 Yih-Chun Hu

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

    Yohanes Nugroho (yohanes@opensource.or.id)
    Kp Areman RT 09/08 No 71 Desa Tugu Cimanggis Depok 16951 Indonesia
*/


#ifndef __VERSE_INFO_H
#define __VERSE_INFO_H

class VerseInfo
{
	public:
	int chapter;
	int verse;
	int linecount;
	int verseline; /*first line of verse for numbering*/
	/** Next verse */
	VerseInfo *next;
	/** Prev verse */
	VerseInfo *prev;
	/** Verse content */
	HBufC **vcontent;
	int vcount;
	
	/** Verse text, parsed in lines */
	CArrayFix<TPtrC>* lines;
	CArrayFix<TInt>* lineformat;	

	VerseInfo(int chapter, int verse)/*: booktext(0), chaptext(0), desctext(0), vcontent(0), next(0), prev(0),
		     booklines(0), chaplines(0), desclines(0),lines(0)*/
	  {
		linecount = 0;
		vcount = 0;
	    next = NULL;
	    prev = NULL;
	    lines = NULL;
		lineformat = NULL;
		this->chapter = chapter;
		this->verse = verse;
	  }

	~VerseInfo()
	  {
	  
	    delete lines;
		delete lineformat;
		for (int i = 0; i<vcount; i++){
			delete vcontent[i];
		}
		delete vcontent;
	  }

	int lessThan(VerseInfo *v) {
	  return (chapter<v->chapter || (chapter==v->chapter && verse<=v->verse));
	}

	int lessThan(int chapter, int verse){
	  return (this->chapter<chapter || (this->chapter==chapter && this->verse<=verse));
	}
};

#endif
