/*
    S60Bible A Bible Reader for SymbianOS
    Copyright (C) 2004 Yohanes Nugroho

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

    Yohanes Nugroho (yohanes@opensource.or.id)
    Kp Areman RT 09/08 No 71 Desa Tugu Cimanggis Depok 16951 Indonesia
*/
#ifndef INFO_H
#define INFO_H

#include "const.h"

#define infVerInfoRecord 0
#define infCopyProtected        0x01
#define infByteNotShifted       0x02
#define infRightAligned         0x04


typedef struct BookInfoType {
        UInt16 bookNum;
        UInt16 bookIndex;
        UInt16 totalBookRec;
        char simpleName[8];
        char complexName[32];
} /*__attribute__((packed))*/ BookInfoType;

typedef BookInfoType *BookInfoPtr;

typedef struct VersionInfoType {
        char versionName[16]; /*0 */
        char versionInfo[128]; /*16 */
        char sepChar;
        UInt8 versionAttrib; /**128+2+16= 130+16=146*/
        UInt16 wordIndex;
        UInt16 totalWordRec;
        UInt16 totalBooks; /*16*3+146 = 194*/
        BookInfoType *bookInfo; // bookInfo array
} /*__attribute__((packed))*/ VersionInfoType;

typedef VersionInfoType *VersionInfoPtr;

typedef struct ListContainType {
	        char **nameList;
	        UInt16 *numList;
	        UInt16 totalValue;
} /*__attribute__((packed))*/ ListContainType;
typedef ListContainType *ListContainPtr;


#endif
