#include "PDBAccess.h"
#include "info.h"
#include "Decoder.h"
#include "Reader.h"
#include "big5.h"
#include <sys/stat.h>
#include <sys/types.h>
//#define TEST_ALL

char buff[8192];
char buff_uni[8192*2];
UInt16 linefmt[4096];
UInt16 linepos[4096];

#define MBFL_WCSGROUP_MASK                0xffffff
#define MBFL_WCSPLANE_BIG5           0x70f40000              /*  2121h - 9898h */
#define MBFL_WCSGROUP_THROUGH           0x78000000              /* 000000h - FFFFFFh */
#define MBFL_WCSPLANE_MASK                      0xffff


void big5_to_unicode(char *big5, short *unicode, int *res)
{
  int status = 0;
  char *s = big5;
  *res = 0;
  unsigned char c1 = 0;
  int w;
  while (*s) {
    switch (status) {
      case 0:{
	unsigned char c = *s;
	  s++;
	  if (c < 0x80) { //latin
	  unicode[(*res)++] = *s;
	  continue;
	} else if (c > 0xa0 && c < 0xff) {      /* dbcs lead byte */
	  status = 1;
	  c1 = c;
	  continue;
	} else {
	  w = c & MBFL_WCSGROUP_MASK;
	  w |= MBFL_WCSGROUP_THROUGH;
	  unicode[(*res)++] = w;
	}	
	break;
      }
      case 1:{
	/* dbcs second byte */
	unsigned char c = *s;
	s++;
	status = 0;
	if ((c > 0x39 && c < 0x7f) | (c > 0xa0 && c < 0xff)) {
	  if (c < 0x7f){
	    w = (c1 - 0xa1)*157 + (c - 0x40);
	  } else {
	    w = (c1 - 0xa1)*157 + (c - 0xa1) + 0x3f;
	  }
	  if (w >= 0 && w < big5_ucs_table_size) {
	    w = big5_ucs_table[w];
	  } else {
	    w = 0;
	  }
	  if (w <= 0) {
	    w = (c1 << 8) | c;
	    w &= MBFL_WCSPLANE_MASK;
	    w |= MBFL_WCSPLANE_BIG5;
	  }
	  unicode[(*res)++] = w;
	} else if (c < 0x21 || c == 0x7f) {         /* CTLs */
	  unicode[(*res)++] = *s;
	} else {
	  w = (c1 << 8) | c;
	  w &= MBFL_WCSGROUP_MASK;
	  w |= MBFL_WCSGROUP_THROUGH;
	  unicode[(*res)++] = w;
	}
	break;
      }
      default:
	status = 0;

    }
  }
}

int main(int argc, char *argv[])
{
	RFs dummy;

	Reader *rd = new Reader();
	//rd->ConstructL(dummy, "cuv_big5.pdb");
	//rd->ConstructL(dummy, "jskug_sjis.pdb");
	//rd->ConstructL(dummy, "kjvjh.PDB");
	rd->ConstructL(dummy, "tb.pdb");
	//rd->ConstructL(dummy, "Barnes.PDB");
	rd->SeekVerse(1, rd->GetFirstBook(), 1, 1);

#ifdef TEST_ALL
	int nextbook = rd->GetFirstBook();
	do {
	char *bookname = rd->BookName();
 	printf("%d %s",  nextbook, bookname);
	free(bookname);

	  for (int chapter = 1;   chapter<rd->getTotalChapter(); chapter++) {
	    for(int verse = 1;verse<rd->getTotalVerse(chapter); verse++) {
		  memset(buff, 0, sizeof(buff));
		  //rd->GetCurrentTextAsString(buff, Decoder::bookTextType);
		  // rd->GetCurrentTextAsString(buff, Decoder::descTextType);
		  rd->GetCurrentVerseAsString(buff);
		   printf("[%d] %s\n", verse, buff);
		  rd->MoveNextVerse();
		}
	  } 
	  nextbook = rd->GetNextBook();
	  if (nextbook>0) {
	    rd->SeekVerse(1, nextbook, 1, 1);	    
	  }
	} while (nextbook>0);
#else
	for (int chapter = 1;   chapter<2; chapter++) {
	  for(int verse = 1;verse<2; verse++) {
	      memset(buff, 0, sizeof(buff));
	      // rd->GetCurrentVerseAsString(buff);
	      int linecount;
	      rd->GetCurrentVerseAsStringF(buff,linepos, linefmt, &linecount);
	      printf("linecount : %d\n", linecount);
	      printf("%s\n", buff);
	      for (int i = 0; i<linecount; i++){
		printf("linepos[%d] = %d\n", i, linepos[i]);
		printf("linefmt[%d] = %d\n", i, linefmt[i]);
	      }
	      //printf("[%d] %s\n", verse, buff);
	      //int res;
	      //big5_to_unicode(buff, (short *)buff_uni, &res);
	      //for (int i = 0; i<res*2; i++){
	      //printf("%c", buff_uni[i]);
	      // }
	      rd->MoveNextVerse();
	    }
	} 
#endif
	delete rd;
	return 0;
}
